program prog_rotate
use rot
use sep3d_struct_mod
use sep
implicit none
type(sep3d) :: rot_in,rot_out
integer :: block_size,i_rho,n_rho,i_gamma,n_gamma
real :: centz,centx,angle
real,allocatable :: panel(:,:)
integer,external :: sreed,srite


call initpar
call from_param('centz',centz,0.0)
call from_param('centx',centx,0.0)
call from_param('angle',angle,0.0)

call init_sep3d("in",rot_in,"INPUT")
call init_sep3d(rot_out,"OUTPUT","FLOAT","REGULAR",ctag="out")
call axis_allocate(rot_out,4)
rot_out%n=rot_in%n
rot_out%d=rot_in%d
rot_out%o=rot_in%o

!rot_out%n(3)=1
!rot_out%n(4)=1
call sep3d_set_sep3d(rot_out)
call sep3d_write_description("out",rot_out)


n_rho=rot_in%n(4)
n_gamma=rot_in%n(3)
!n_rho=1
!n_gamma=1
allocate(panel(rot_in%n(1),rot_in%n(2)) )
call rot_init(rot_in%n(1),rot_in%n(2),rot_in%d(1),rot_in%d(2),rot_in%n(1),rot_in%n(2) )



block_size=rot_in%n(1)*rot_in%n(2)

do i_rho=1,n_rho
  do i_gamma=1,n_gamma
    if (sreed("in",panel,4*block_size) /= 4*block_size ) then
      call seperr("wrong read data")
    end if
    call rotate_fourier(panel,centz,centx,cos(-angle/180.0*3.1415926),sin(-angle/180.0*3.1415926))
!    call rotate_fourier(panel,750.0,930.0,cos(-60.0/180.0*3.1415926),sin(-60.0/180.0*3.1415926))
!    call rotate_fourier(panel,470.0,1100.0,cos(-45.0/180.0*3.1415926),sin(-45.0/180.0*3.1415926))
    if (srite("out",panel,4*block_size) /= 4*block_size ) then
      call seperr("wrong write data")
    end if
  end do 
end do
call rot_release
end program prog_rotate
